var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
import styled from '@emotion/styled';
import { Colors } from '@blueprintjs/core';
function isNumber(x) {
    return typeof x === 'number';
}
export var Column = styled.div(function (_a) {
    var _b = _a.spacing, spacing = _b === void 0 ? 0 : _b, _c = _a.padding, padding = _c === void 0 ? 0 : _c;
    return "\n  display: flex;\n  flex-direction: column;\n  padding: " + (isNumber(padding) ? padding + "px" : padding) + ";\n  & > * + * { margin-top: " + spacing + "px; }\n";
});
export var Row = styled.div(function (_a) {
    var _b = _a.spacing, spacing = _b === void 0 ? 0 : _b;
    return "\n  display: flex;\n  flex-direction: row;\n  align-items: center;\n  & > * + * { margin-left: " + spacing + "px; }\n";
});
export var Absolute = styled.div(function (_a) {
    var top = _a.top, left = _a.left, right = _a.right, bottom = _a.bottom;
    return "\n  position: absolute;\n  " + (top != null ? "top: " + top + "px;" : '') + "\n  " + (left != null ? "left: " + left + "px;" : '') + "\n  " + (right != null ? "right: " + right + "px;" : '') + "\n  " + (bottom != null ? "bottom: " + bottom + "px;" : '') + "\n";
});
export var getBoxStyle = function (props) { return "\n  background: " + (props.darkMode ? Colors.DARK_GRAY5 : "rgba(255, 255, 255, 0.9)") + ";\n  border-radius: 4px;\n  font-size: 11px;\n  box-shadow: 0 0 5px #aaa; \n"; };
export var BoxStyle = styled.div(getBoxStyle);
export var Box = styled(Absolute)(getBoxStyle);
export var TitleBox = styled(Box)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  line-height: 1.3;\n  font-size: 13px;\n  border-top-left-radius: 0;\n  border-bottom-left-radius: 0;\n"], ["\n  line-height: 1.3;\n  font-size: 13px;\n  border-top-left-radius: 0;\n  border-bottom-left-radius: 0;\n"])));
export var Title = styled.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  font-weight: bold;\n  font-size: 18px;\n  margin-bottom: 10px;\n"], ["\n  font-weight: bold;\n  font-size: 18px;\n  margin-bottom: 10px;\n"])));
export var Description = styled.div(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  max-height: 155px;\n  overflow: auto;\n"], ["\n  max-height: 155px;\n  overflow: auto;\n"])));
export var LegendTitle = styled.div(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  font-weight: bold;\n  font-size: 13px;\n"], ["\n  font-weight: bold;\n  font-size: 13px;\n"])));
export var ToastContent = styled.div(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  font-size: 12px;\n"], ["\n  font-size: 12px;\n"])));
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5;
//# sourceMappingURL=Boxes.js.map