var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import * as React from 'react';
import styled from '@emotion/styled';
import { Colors } from '@blueprintjs/core';
export var Direction;
(function (Direction) {
    Direction[Direction["LEFT"] = 0] = "LEFT";
    Direction[Direction["RIGHT"] = 1] = "RIGHT";
})(Direction || (Direction = {}));
var Outer = styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  display: flex;\n  justify-items: center;\n  flex-direction: row;\n"], ["\n  display: flex;\n  justify-items: center;\n  flex-direction: row;\n"])));
var Body = styled.div(function (_a) {
    var direction = _a.direction, collapsed = _a.collapsed, width = _a.width;
    return "\n  order: " + (direction === Direction.LEFT ? 2 : 1) + ";\n  overflow: hidden;\n  max-width: " + (collapsed ? 0 : width + "px") + ";\n  transition: max-width 0.15s ease-out;  \n";
});
var Content = styled.div(function (_a) {
    var direction = _a.direction, width = _a.width;
    return "\n  width: " + width + "px;\n";
});
var Rotate = styled.div(function (_a) {
    var degrees = _a.degrees;
    return "\n  transform-origin: center;\n  transform: rotate(" + degrees + "deg);\n  transition: transform 0.15s ease-out;  \n";
});
var Button = styled.button(function (_a) {
    var collapsed = _a.collapsed, direction = _a.direction, darkMode = _a.darkMode;
    return "\n  display: flex;\n  order: " + (direction === Direction.LEFT ? 1 : 2) + ";  \n  border: none;\n  cursor: pointer;\n  align-items: center;\n  font-size: 22px;\n  background-color: " + (darkMode ? Colors.DARK_GRAY4 : Colors.LIGHT_GRAY5) + ";\n  color: #ccc;\n  border-radius: " + (collapsed ? 4 : 0) + "px;\n  transition: background-color 0.25s, border-radius 0.15s;  \n  &:hover {\n    background-color: " + (darkMode ? Colors.DARK_GRAY3 : Colors.LIGHT_GRAY4) + ";\n  }\n";
});
var Collapsible = /** @class */ (function (_super) {
    __extends(Collapsible, _super);
    function Collapsible() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            collapsed: _this.props.initialCollapsed != null
                ? _this.props.initialCollapsed
                : Collapsible.defaultProps.initialCollapsed,
        };
        _this.bodyRef = React.createRef();
        _this.handleClick = function () {
            _this.setState(function (state) { return ({
                collapsed: !state.collapsed,
            }); });
        };
        _this.getArrow = function () {
            var direction = _this.props.direction;
            var collapsed = _this.state.collapsed;
            switch (direction) {
                case Direction.LEFT:
                    return React.createElement(Rotate, { degrees: collapsed ? 180 : 360 }, '<');
                case Direction.RIGHT:
                    return React.createElement(Rotate, { degrees: collapsed ? 180 : 360 }, '>');
            }
        };
        return _this;
    }
    Collapsible.prototype.render = function () {
        var _a = this.props, width = _a.width, direction = _a.direction, darkMode = _a.darkMode, children = _a.children;
        var collapsed = this.state.collapsed;
        return (React.createElement(Outer, null,
            React.createElement(Body, { ref: this.bodyRef, width: width, direction: direction, collapsed: collapsed },
                React.createElement(Content, { width: width, direction: direction }, children)),
            React.createElement(Button, { darkMode: darkMode, collapsed: collapsed, direction: direction, onClick: this.handleClick },
                ' ',
                this.getArrow())));
    };
    Collapsible.defaultProps = {
        initialCollapsed: false,
    };
    return Collapsible;
}(React.Component));
export default Collapsible;
var templateObject_1;
//# sourceMappingURL=Collapsible.js.map