import { ColorScheme } from './colors';
import { Link } from 'react-router-dom';
import * as React from 'react';
import styled from '@emotion/styled';
import { Row } from './Boxes';
var SHADOW_COLOR = ColorScheme.primary;
var LogoText = styled.div(function (_a) {
    var _b;
    var fontSize = _a.fontSize, collapseWidth = _a.collapseWidth;
    return (_b = {
            // fontFamily: "'Titillium Web', sans-serif",
            fontSize: fontSize,
            color: '#fff',
            fontWeight: 'bold',
            textShadow: "1px -1px 1px " + SHADOW_COLOR + ", \n    1px 1px 1px " + SHADOW_COLOR + ", \n    -1px -1px 1px " + SHADOW_COLOR + ", \n    -1px 1px 1px " + SHADOW_COLOR
        },
        _b["@media (max-width: " + collapseWidth + "px)"] = {
            display: 'none',
        },
        _b);
});
var Logo = function (_a) {
    var _b = _a.fontSize, fontSize = _b === void 0 ? 25 : _b, _c = _a.collapseWidth, collapseWidth = _c === void 0 ? 525 : _c, embed = _a.embed;
    var size = Math.ceil(fontSize * 1.5);
    var content = React.createElement(Row, { spacing: fontSize / 5 },
        React.createElement("svg", { width: size, height: size, viewBox: "0 0 402 402" },
            React.createElement("g", { transform: "translate(1 1)", stroke: "none", strokeWidth: 1, fill: "none", fillRule: "evenodd" },
                React.createElement("circle", { stroke: "#979797", fill: "#1A70A7", cx: 200, cy: 200, r: 200 }),
                React.createElement("path", { d: "M265.5 199.045h42.545L216.5 320.411V84.5h49v114.545zM135.5 202.955H92.955L184.5 81.589V317.5h-49V202.955z", strokeOpacity: 0.937273551, stroke: "#FFF", strokeWidth: 13, strokeLinejoin: "round" }))),
        React.createElement(LogoText, { collapseWidth: collapseWidth, fontSize: fontSize }, "flowmap.blue"));
    if (embed) {
        return (React.createElement("a", { href: "https://flowmap.blue", style: { textDecoration: 'none' }, target: "_blank", rel: "noopener noreferrer" }, content));
    }
    return (React.createElement(Link, { to: "/", style: { textDecoration: 'none' } }, content));
};
export default Logo;
//# sourceMappingURL=Logo.js.map