import React from 'react';
import { Feature, Polygon } from 'geojson';
export declare enum MapDrawingMode {
    POLYGON = "POLYGON"
}
export declare type MapDrawingFeature = Feature<Polygon, {
    renderType: 'Polygon' | 'Rectangle';
    bbox: {
        xmin: number;
        xmax: number;
        ymin: number;
        ymax: number;
    };
    isClosed?: boolean;
}>;
export interface Props {
    mapDrawingMode: MapDrawingMode;
    onFeatureDrawn: (feature: MapDrawingFeature | undefined) => void;
}
export declare const HANDLE_RADIUS = 5;
export declare const HANDLE_STROKE: {
    [x: number]: string;
    DEFAULT: string;
};
export declare const HANDLE_FILL: {
    [x: number]: string;
    DEFAULT: string;
};
export declare const FEATURE_STROKE: {
    [x: number]: string;
    DEFAULT: string;
};
export declare const FEATURE_FILL: {
    [x: number]: string;
    DEFAULT: string;
};
declare const MapDrawingEditor: React.FC<Props>;
export default MapDrawingEditor;
//# sourceMappingURL=MapDrawingEditor.d.ts.map