var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import React from 'react';
import styled from '@emotion/styled';
import { Colors } from '@blueprintjs/core';
var width = 40, height = 40;
var OuterSvg = styled.svg(function (props) { return ({
    cursor: 'pointer',
    '& > circle': {
        transition: 'fill 0.2s',
        fill: props.darkMode ? Colors.GRAY4 : Colors.WHITE,
    },
    '&:hover': {
        '& > circle': {
            fill: props.darkMode ? Colors.WHITE : Colors.GRAY4,
        },
    },
}); });
var OuterCircle = styled.circle({
    cursor: 'pointer',
    strokeWidth: 1,
    stroke: '#000',
});
var PlayControl = /** @class */ (function (_super) {
    __extends(PlayControl, _super);
    function PlayControl() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.start = function () {
            var _a = _this.props, isPlaying = _a.isPlaying, onPlay = _a.onPlay;
            if (!isPlaying) {
                var _b = _this.props, extent = _b.extent, current = _b.current, onAdvance = _b.onAdvance;
                onPlay();
                _this.scheduleNextStep();
                if (current >= extent[1]) {
                    // rewind
                    onAdvance(extent[0]);
                }
            }
        };
        _this.stop = function () {
            _this.clearPlayTimeOut();
            var _a = _this.props, isPlaying = _a.isPlaying, onPause = _a.onPause;
            if (isPlaying) {
                onPause();
            }
        };
        _this.clearPlayTimeOut = function () {
            if (_this.playTimeout != null) {
                clearTimeout(_this.playTimeout);
                _this.playTimeout = undefined;
            }
        };
        _this.scheduleNextStep = function () {
            _this.clearPlayTimeOut();
            var stepDuration = _this.props.stepDuration;
            _this.playTimeout = setTimeout(_this.nextStep, stepDuration);
        };
        _this.nextStep = function () {
            var _a = _this.props, isPlaying = _a.isPlaying, speed = _a.speed;
            if (isPlaying) {
                var _b = _this.props, interval = _b.interval, extent = _b.extent, current = _b.current, onAdvance = _b.onAdvance;
                // @ts-ignore
                var numSteps = interval.count(extent[0], extent[1]);
                var next = interval.offset(current, speed * Math.max(1, Math.floor(numSteps / 60)));
                if (next > extent[1]) {
                    _this.stop();
                }
                else {
                    onAdvance(next);
                    _this.scheduleNextStep();
                }
            }
        };
        return _this;
    }
    PlayControl.prototype.componentWillUnmount = function () {
        this.clearPlayTimeOut();
    };
    PlayControl.prototype.render = function () {
        var _this = this;
        var _a = this.props, isPlaying = _a.isPlaying, darkMode = _a.darkMode;
        var handleTogglePlay = function () {
            if (isPlaying) {
                _this.stop();
            }
            else {
                _this.start();
            }
        };
        var icon;
        if (!isPlaying) {
            icon = (React.createElement("path", { fill: "#000", d: "M16 10c0-.36-.2-.67-.49-.84l.01-.01-10-6-.01.01A.991.991 0 005 3c-.55 0-1 .45-1 1v12c0 .55.45 1 1 1 .19 0 .36-.07.51-.16l.01.01 10-6-.01-.01c.29-.17.49-.48.49-.84z", transform: "translate(.5)" }));
        }
        else {
            icon = (React.createElement("path", { fill: "#000", d: "M7 3H4c-.55 0-1 .45-1 1v12c0 .55.45 1 1 1h3c.55 0 1-.45 1-1V4c0-.55-.45-1-1-1zm9 0h-3c-.55 0-1 .45-1 1v12c0 .55.45 1 1 1h3c.55 0 1-.45 1-1V4c0-.55-.45-1-1-1z" }));
        }
        var r = Math.min(width, height) * 0.48;
        return (React.createElement(OuterSvg, { darkMode: darkMode, width: width, height: height, onClick: handleTogglePlay },
            React.createElement(OuterCircle, { cx: width / 2, cy: height / 2, r: r }),
            React.createElement("g", { transform: "translate(" + (width / 2 - 10) + "," + (height / 2 - 10) + ")" }, icon)));
    };
    PlayControl.defaultProps = {
        speed: 1,
    };
    return PlayControl;
}(React.Component));
export default PlayControl;
//# sourceMappingURL=PlayControl.js.map