import { ItemPredicate, ItemRenderer } from '@blueprintjs/select';
import React from 'react';
import { LocationFilterMode } from './FlowMap.state';
export interface Props<Item> {
    placeholder: string;
    items: Item[];
    maxItems: number;
    selectedItems: Item[] | undefined;
    itemPredicate: ItemPredicate<Item>;
    itemRenderer: ItemRenderer<Item>;
    tagRenderer: (item: Item) => React.ReactNode;
    onSelected: (item: Item) => void;
    onRemoved: (item: Item) => void;
    onCleared: () => void;
    onQueryChange?: (query: string) => void;
    locationFilterMode: LocationFilterMode;
    onLocationFilterModeChange: (mode: LocationFilterMode) => void;
}
interface State {
    query: string;
}
declare function filterItems<Item>(items: Item[], query: string, itemPredicate: ItemPredicate<Item>, maxLength: number): Item[];
export default class SearchBox<Item> extends React.PureComponent<Props<Item>, State> {
    state: {
        query: string;
    };
    getFilteredItems: typeof filterItems;
    render(): JSX.Element;
    private handleQueryChange;
    private handleItemRemoved;
}
export {};
//# sourceMappingURL=SearchBox.d.ts.map