var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
import { Button, Menu, MenuDivider, MenuItem, Popover, Position, } from '@blueprintjs/core';
import { IconNames } from '@blueprintjs/icons';
import { MultiSelect } from '@blueprintjs/select';
import React from 'react';
import { defaultMemoize } from 'reselect';
import { LocationFilterMode } from './FlowMap.state';
import { Column } from './Boxes';
import { ClassNames } from '@emotion/core';
var NoResultsItem = React.createElement(MenuItem, { disabled: true, text: "No matches." });
var popoverProps = {
    minimal: true,
    usePortal: false,
    hoverOpenDelay: 0,
};
function filterItems(items, query, itemPredicate, maxLength) {
    var e_1, _a;
    var matches = [];
    if (!items || items.length === 0) {
        return matches;
    }
    try {
        for (var items_1 = __values(items), items_1_1 = items_1.next(); !items_1_1.done; items_1_1 = items_1.next()) {
            var item = items_1_1.value;
            if (itemPredicate(query, item)) {
                matches.push(item);
            }
            if (matches.length >= maxLength) {
                break;
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (items_1_1 && !items_1_1.done && (_a = items_1.return)) _a.call(items_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return matches;
}
var SearchBox = /** @class */ (function (_super) {
    __extends(SearchBox, _super);
    function SearchBox() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            query: '',
        };
        _this.getFilteredItems = defaultMemoize(filterItems);
        _this.handleQueryChange = function (query) {
            _this.setState({
                query: query,
            });
            var onQueryChange = _this.props.onQueryChange;
            if (onQueryChange) {
                onQueryChange(query);
            }
        };
        _this.handleItemRemoved = function (value, index) {
            var _a = _this.props, selectedItems = _a.selectedItems, onRemoved = _a.onRemoved;
            if (selectedItems) {
                onRemoved(selectedItems[index]);
            }
        };
        return _this;
    }
    SearchBox.prototype.render = function () {
        var _a = this.props, items = _a.items, selectedItems = _a.selectedItems, itemRenderer = _a.itemRenderer, placeholder = _a.placeholder, tagRenderer = _a.tagRenderer, onCleared = _a.onCleared, onSelected = _a.onSelected, itemPredicate = _a.itemPredicate, maxItems = _a.maxItems, locationFilterMode = _a.locationFilterMode, onLocationFilterModeChange = _a.onLocationFilterModeChange;
        var query = this.state.query;
        var tagInputProps = {
            placeholder: placeholder,
            onRemove: this.handleItemRemoved,
            leftIcon: IconNames.SEARCH,
            rightElement: selectedItems && selectedItems.length > 0 ? (React.createElement(Column, null,
                React.createElement(Button, { icon: IconNames.CROSS, minimal: true, onClick: onCleared }),
                React.createElement(Popover, { position: Position.TOP_RIGHT, minimal: true, usePortal: false, hoverOpenDelay: 0, hoverCloseDelay: 0, content: React.createElement(ClassNames, null, function (_a) {
                        var css = _a.css;
                        return (React.createElement(Menu, null,
                            React.createElement(MenuDivider, { title: "Filter mode" }),
                            [
                                { value: LocationFilterMode.ALL, label: 'All' },
                                { value: LocationFilterMode.INCOMING, label: 'Incoming to selected' },
                                { value: LocationFilterMode.OUTGOING, label: 'Outgoing from selected' },
                                { value: LocationFilterMode.BETWEEN, label: 'Between selected' },
                            ].map(function (v) { return (React.createElement(MenuItem, { active: locationFilterMode === v.value, icon: locationFilterMode === v.value
                                    ? IconNames.TICK_CIRCLE
                                    : IconNames.SMALL_TICK, key: v.value, text: v.label, onClick: function () { return onLocationFilterModeChange(v.value); }, textClassName: css({
                                    fontSize: '11px',
                                }) })); })));
                    }) },
                    React.createElement(Button, { title: "Filter mode", icon: IconNames.COG, minimal: true })))) : (undefined),
        };
        return (React.createElement(MultiSelect, { items: this.getFilteredItems(items, query, itemPredicate, maxItems), selectedItems: selectedItems, itemRenderer: itemRenderer, tagRenderer: tagRenderer, noResults: NoResultsItem, popoverProps: popoverProps, tagInputProps: tagInputProps, onItemSelect: onSelected, resetOnSelect: true, openOnKeyDown: true, onQueryChange: this.handleQueryChange }));
    };
    return SearchBox;
}(React.PureComponent));
export default SearchBox;
//# sourceMappingURL=SearchBox.js.map