var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
import { Column, LegendTitle, Row } from './Boxes';
import { Button, Popover, Slider, Switch } from '@blueprintjs/core';
import { IconNames } from '@blueprintjs/icons';
import * as React from 'react';
import styled from '@emotion/styled';
import { ActionType } from './FlowMap.state';
import ColorSchemeSelector from './ColorSchemeSelector';
var SettingsOuter = styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  width: 290px;\n  font-size: 12px;\n"], ["\n  width: 290px;\n  font-size: 12px;\n"])));
var StyledSwitch = styled(Switch)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  margin-bottom: 0;\n  align-self: flex-start;\n  white-space: nowrap;\n"], ["\n  margin-bottom: 0;\n  align-self: flex-start;\n  white-space: nowrap;\n"])));
var SettingsPopover = function (_a) {
    var dispatch = _a.dispatch, state = _a.state, darkMode = _a.darkMode, clusterZoom = _a.clusterZoom, availableClusterZoomLevels = _a.availableClusterZoomLevels, onChangeClusteringAuto = _a.onChangeClusteringAuto;
    var handleToggleClustering = function (evt) {
        var value = evt.target.checked;
        dispatch({
            type: ActionType.SET_CLUSTERING_ENABLED,
            clusteringEnabled: value,
        });
    };
    var handleToggleClusteringAuto = function (evt) {
        var value = evt.target.checked;
        onChangeClusteringAuto(value);
    };
    var handleChangeManualClusterZoom = function (index) {
        dispatch({
            type: ActionType.SET_MANUAL_CLUSTER_ZOOM,
            manualClusterZoom: availableClusterZoomLevels
                ? availableClusterZoomLevels[availableClusterZoomLevels.length - 1 - index]
                : undefined,
        });
    };
    var handleToggleDarkMode = function (evt) {
        var value = evt.target.checked;
        dispatch({
            type: ActionType.SET_DARK_MODE,
            darkMode: value,
        });
    };
    var handleToggleFadeEnabled = function (evt) {
        var value = evt.target.checked;
        dispatch({
            type: ActionType.SET_FADE_ENABLED,
            fadeEnabled: value,
        });
    };
    var handleToggleBaseMap = function (evt) {
        var value = evt.target.checked;
        dispatch({
            type: ActionType.SET_BASE_MAP_ENABLED,
            baseMapEnabled: value,
        });
    };
    var handleChangeFadeAmount = function (value) {
        dispatch({
            type: ActionType.SET_FADE_AMOUNT,
            fadeAmount: value,
        });
    };
    var handleChangeBaseMapOpacity = function (value) {
        dispatch({
            type: ActionType.SET_BASE_MAP_OPACITY,
            baseMapOpacity: value,
        });
    };
    var handleChangeColorScheme = function (colorSchemeKey) {
        dispatch({
            type: ActionType.SET_COLOR_SCHEME,
            colorSchemeKey: colorSchemeKey,
        });
    };
    var handleToggleAnimation = function (evt) {
        var value = evt.target.checked;
        dispatch({
            type: ActionType.SET_ANIMATION_ENABLED,
            animationEnabled: value,
        });
    };
    var handleToggleLocationTotals = function (evt) {
        var value = evt.target.checked;
        dispatch({
            type: ActionType.SET_LOCATION_TOTALS_ENABLED,
            locationTotalsEnabled: value,
        });
    };
    var handleToggleAdaptiveScales = function (evt) {
        var value = evt.target.checked;
        dispatch({
            type: ActionType.SET_ADAPTIVE_SCALES_ENABLED,
            adaptiveScalesEnabled: value,
        });
    };
    return (React.createElement(Popover, { usePortal: false, hoverOpenDelay: 0, hoverCloseDelay: 0, content: React.createElement(SettingsOuter, null,
            React.createElement(Column, { spacing: 10, padding: "12px 20px" },
                React.createElement(LegendTitle, null, "Settings"),
                React.createElement(Row, { spacing: 5 },
                    React.createElement("div", { style: { whiteSpace: 'nowrap' } }, "Color scheme"),
                    React.createElement(ColorSchemeSelector, { selected: state.colorSchemeKey, reverse: darkMode, onChange: handleChangeColorScheme })),
                React.createElement(Column, { spacing: 10 },
                    React.createElement(StyledSwitch, { checked: state.darkMode, label: "Dark mode", onChange: handleToggleDarkMode }),
                    React.createElement(Row, { spacing: 15 },
                        React.createElement(StyledSwitch, { checked: state.fadeEnabled, label: "Fade", onChange: handleToggleFadeEnabled }),
                        state.fadeEnabled && React.createElement(Slider, { value: state.fadeAmount, min: 0, max: 100, stepSize: 1, labelRenderer: false, showTrackFill: false, onChange: handleChangeFadeAmount })),
                    React.createElement(Row, { spacing: 15 },
                        React.createElement(StyledSwitch, { checked: state.baseMapEnabled, label: "Base map", onChange: handleToggleBaseMap }),
                        state.baseMapEnabled && (React.createElement(Slider, { value: state.baseMapOpacity, min: 0, max: 100, stepSize: 1, labelRenderer: false, showTrackFill: false, onChange: handleChangeBaseMapOpacity }))),
                    React.createElement(StyledSwitch, { checked: state.animationEnabled, label: "Animate flows", onChange: handleToggleAnimation }),
                    React.createElement(StyledSwitch, { checked: state.adaptiveScalesEnabled, label: "Adaptive scales", onChange: handleToggleAdaptiveScales }),
                    React.createElement(StyledSwitch, { checked: state.locationTotalsEnabled, label: "Location totals", onChange: handleToggleLocationTotals }),
                    availableClusterZoomLevels &&
                        React.createElement(React.Fragment, null,
                            React.createElement(Row, { spacing: 15 },
                                React.createElement(StyledSwitch, { checked: state.clusteringEnabled, label: "Clustering", onChange: handleToggleClustering }),
                                state.clusteringEnabled &&
                                    React.createElement(StyledSwitch, { checked: state.clusteringAuto, innerLabel: state.clusteringAuto ? 'Auto' : 'Manual', onChange: handleToggleClusteringAuto })),
                            state.clusteringEnabled && !state.clusteringAuto &&
                                React.createElement(Row, { spacing: 15 },
                                    React.createElement("div", { style: { whiteSpace: 'nowrap' } }, "Clustering level"),
                                    React.createElement(Slider, { value: availableClusterZoomLevels.length - 1 -
                                            (availableClusterZoomLevels.indexOf(state.manualClusterZoom != null
                                                ? state.manualClusterZoom
                                                : clusterZoom || 0)), min: 0, max: availableClusterZoomLevels.length - 1, stepSize: 1, labelRenderer: false, showTrackFill: false, onChange: handleChangeManualClusterZoom })))))) },
        React.createElement(Button, { title: "Settings\u2026", icon: IconNames.COG })));
};
export default SettingsPopover;
var templateObject_1, templateObject_2;
//# sourceMappingURL=SettingsPopover.js.map