var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
import * as React from 'react';
import { Popper } from 'react-popper';
import styled from '@emotion/styled';
var VirtualReference = /** @class */ (function () {
    function VirtualReference(target) {
        this.target = target;
    }
    VirtualReference.prototype.getBoundingClientRect = function () {
        var _a = this.target, left = _a.left, top = _a.top, width = _a.width, height = _a.height;
        return {
            top: top,
            left: left,
            bottom: top + height,
            right: left + width,
            width: width,
            height: height,
        };
    };
    Object.defineProperty(VirtualReference.prototype, "clientWidth", {
        get: function () {
            return this.target.width;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(VirtualReference.prototype, "clientHeight", {
        get: function () {
            return this.target.height;
        },
        enumerable: false,
        configurable: true
    });
    return VirtualReference;
}());
var ContentWrapper = styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  pointer-events: none;\n  background: #224455;\n  color: #fff;\n  border-radius: 5px;\n  padding: 7px;\n"], ["\n  pointer-events: none;\n  background: #224455;\n  color: #fff;\n  border-radius: 5px;\n  padding: 7px;\n"])));
var Tooltip = function (_a) {
    var target = _a.target, content = _a.content, placement = _a.placement;
    return (React.createElement(Popper, { placement: placement, referenceElement: new VirtualReference(target) }, function (_a) {
        var ref = _a.ref, style = _a.style, placement = _a.placement, arrowProps = _a.arrowProps;
        return (React.createElement(ContentWrapper, { ref: ref, style: style, "data-placement": placement },
            content,
            React.createElement("div", { ref: arrowProps.ref, style: arrowProps.style })));
    }));
};
export default Tooltip;
var templateObject_1;
//# sourceMappingURL=Tooltip.js.map