var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
import * as React from 'react';
import { getFlowMagnitude } from './types';
import styled from '@emotion/styled';
import * as d3Format from 'd3-format';
var Outer = styled.div(function (_a) {
    var width = _a.width;
    return "\n  font-size: 10px;\n  width: " + width + "px;\n  display: flex;\n  flex-direction: column;\n  & > * + * {\n    margin-top: 2px;    \n  }\n";
});
var Title = styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  font-weight: bold;\n  margin-bottom: 5px;\n"], ["\n  font-weight: bold;\n  margin-bottom: 5px;\n"])));
var Comment = styled.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  font-size: 9px;\n  opacity: 0.3;\n  margin-top: 0.75em;\n  text-align: center;\n"], ["\n  font-size: 9px;\n  opacity: 0.3;\n  margin-top: 0.75em;\n  text-align: center;\n"])));
var Row = styled.div(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  display: flex;\n  flex-direction: row;\n  width: 100%;\n"], ["\n  display: flex;\n  flex-direction: row;\n  width: 100%;\n"])));
var Label = styled.div(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  display: flex;\n  flex-grow: 1;\n  opacity: 0.7;\n  margin-right: 10px;\n"], ["\n  display: flex;\n  flex-grow: 1;\n  opacity: 0.7;\n  margin-right: 10px;\n"])));
var Value = styled.div(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  display: flex;\n  flex-grow: 1;\n  justify-content: flex-end;\n"], ["\n  display: flex;\n  flex-grow: 1;\n  justify-content: flex-end;\n"])));
export var formatCount = d3Format.format(',.0f');
export var LocationTooltipContent = function (_a) {
    var locationInfo = _a.locationInfo, isSelected = _a.isSelected, isSelectionEmpty = _a.isSelectionEmpty, config = _a.config;
    var location = locationInfo.object, totalIn = locationInfo.totalIn, totalOut = locationInfo.totalOut, totalWithin = locationInfo.totalWithin;
    return (React.createElement(Outer, { width: 150 },
        React.createElement(Title, null, location.name || location.id),
        React.createElement(Row, null,
            React.createElement(Label, null, config['msg.locationTooltip.incoming']),
            React.createElement(Value, null, formatCount(totalIn))),
        React.createElement(Row, null,
            React.createElement(Label, null, config['msg.locationTooltip.outgoing']),
            React.createElement(Value, null, formatCount(totalOut))),
        React.createElement(Row, null,
            React.createElement(Label, null, config['msg.locationTooltip.internal']),
            React.createElement(Value, null, formatCount(totalWithin))),
        React.createElement(Comment, null, isSelected
            ? "Click to remove from selection"
            : isSelectionEmpty
                ? "Click to select this location"
                : "Shift+click to add to selection")));
};
export var FlowTooltipContent = function (_a) {
    var flow = _a.flow, origin = _a.origin, dest = _a.dest, config = _a.config;
    return (React.createElement(Outer, { width: 150 },
        React.createElement(Title, null,
            origin.name || origin.id,
            " \u2192 ",
            dest.name || dest.id),
        React.createElement(Row, null,
            React.createElement(Label, null, config['msg.flowTooltip.numOfTrips']),
            React.createElement(Value, null, formatCount(getFlowMagnitude(flow))))));
};
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5;
//# sourceMappingURL=TooltipContent.js.map