var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import * as ReactDOM from 'react-dom';
import { DEFAULT_CONFIG } from './config';
import FlowMap from './FlowMap';
import { ConfigPropName } from './types';
import MapContainer from './MapContainer';
import { AppToaster, ColorScheme, Fallback } from './index';
import { Router } from 'react-router-dom';
import { createBrowserHistory } from 'history';
import '@blueprintjs/core/lib/css/blueprint.css';
import '@blueprintjs/select/lib/css/blueprint-select.css';
import '@blueprintjs/icons/lib/css/blueprint-icons.css';
import 'mapbox-gl/dist/mapbox-gl.css';
import { css, Global } from '@emotion/core';
import { Classes, Colors, FocusStyleManager } from '@blueprintjs/core';
FocusStyleManager.onlyShowFocusOnTabs();
var history = createBrowserHistory();
var globalStyles = css(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  @import url(\"https://fonts.googleapis.com/css?family=Sarabun:400,700\");\n\n  html,\n  body,\n  button,\n  select {\n    margin: 0;\n    background-color: ", ";\n    font-size: 13pt;\n  }\n               \n  body, * {\n    font-family: 'Sarabun', sans-serif;\n  }\n             \n  a,\n  a:visited {\n    color: ", ";\n  }\n  .", " {\n    a,\n    a:visited {\n      color: ", ";\n    }\n  }\n\n  .mapboxgl-control-container {\n    a,\n    a:visited {\n      color: ", ";\n    }\n  }\n\n  section {\n    margin-bottom: 4em;\n  }\n  #no-token-warning {\n    bottom: 30px;\n    top: unset !important;\n    left: 10px !important;\n  }\n"], ["\n  @import url(\"https://fonts.googleapis.com/css?family=Sarabun:400,700\");\n\n  html,\n  body,\n  button,\n  select {\n    margin: 0;\n    background-color: ", ";\n    font-size: 13pt;\n  }\n               \n  body, * {\n    font-family: 'Sarabun', sans-serif;\n  }\n             \n  a,\n  a:visited {\n    color: ", ";\n  }\n  .", " {\n    a,\n    a:visited {\n      color: ", ";\n    }\n  }\n\n  .mapboxgl-control-container {\n    a,\n    a:visited {\n      color: ", ";\n    }\n  }\n\n  section {\n    margin-bottom: 4em;\n  }\n  #no-token-warning {\n    bottom: 30px;\n    top: unset !important;\n    left: 10px !important;\n  }\n"])), '#2d3a4c', ColorScheme.primary, Classes.DARK, Colors.BLUE5, Colors.DARK_GRAY1);
var ErrorBoundary = /** @class */ (function (_super) {
    __extends(ErrorBoundary, _super);
    function ErrorBoundary() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = { hasError: false, error: null };
        return _this;
    }
    ErrorBoundary.getDerivedStateFromError = function (error) {
        return {
            hasError: true,
            error: error
        };
    };
    ErrorBoundary.prototype.componentDidCatch = function (error, errorInfo) {
        console.error(error);
    };
    ErrorBoundary.prototype.render = function () {
        if (this.state.hasError) {
            var error = this.state.error;
            return (React.createElement(Fallback, null,
                React.createElement(React.Fragment, null,
                    "Oops\u2026 Sorry, but something went wrong.",
                    error && (React.createElement("div", { style: {
                            margin: '10px 0',
                        } }, JSON.stringify(error))))));
        }
        return this.props.children;
    };
    return ErrorBoundary;
}(React.Component));
export function init(_a) {
    var _b;
    var locations = _a.locations, flows = _a.flows, container = _a.container, mapboxAccessToken = _a.mapboxAccessToken, _c = _a.clustering, clustering = _c === void 0 ? true : _c, _d = _a.animation, animation = _d === void 0 ? false : _d, _e = _a.darkMode, darkMode = _e === void 0 ? false : _e;
    AppToaster.init(container);
    ReactDOM.render(React.createElement(Router, { history: history },
        React.createElement(ErrorBoundary, null,
            React.createElement(Global, { styles: globalStyles }),
            React.createElement(MapContainer, { embed: true },
                React.createElement(FlowMap, { inBrowser: true, embed: true, flowsFetch: { value: flows }, locationsFetch: { value: locations }, config: __assign(__assign({}, DEFAULT_CONFIG), (_b = {}, _b[ConfigPropName.MAPBOX_ACCESS_TOKEN] = mapboxAccessToken, _b[ConfigPropName.CLUSTER_ON_ZOOM] = clustering ? 'true' : 'false', _b[ConfigPropName.ANIMATE_FLOWS] = animation ? 'true' : 'false', _b[ConfigPropName.COLORS_DARK_MODE] = darkMode ? 'true' : 'false', _b)), spreadSheetKey: undefined, flowsSheet: undefined })))), container);
}
var templateObject_1;
//# sourceMappingURL=index-standalone.js.map