var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
import { defaultMemoize } from 'reselect';
var splitIntoWords = defaultMemoize(function (str) {
    // https://stackoverflow.com/a/25575009/120779
    return (str
        .toLowerCase()
        // eslint-disable-next-line
        .match(/([^\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,\-.\/:;<=>?@\[\]^_`{|}~\s]+)/g));
});
/**
 * Checks whether the text matches the query. Both are split into words.
 * Returns true if for each query word there is a word in the text which
 * begins with it. Case-insensitive.
 */
export function matchesSearchQuery(query, text) {
    var e_1, _a;
    var queryWords = splitIntoWords(query);
    if (!queryWords || queryWords.length === 0) {
        return true;
    }
    var startsWith = function (queryWord, textWord) { return textWord.indexOf(queryWord) === 0; };
    var textWords = splitIntoWords(text);
    if (!textWords || textWords.length === 0) {
        return false;
    }
    var hasMatch = function (queryWord) {
        var e_2, _a;
        try {
            for (var textWords_1 = __values(textWords), textWords_1_1 = textWords_1.next(); !textWords_1_1.done; textWords_1_1 = textWords_1.next()) {
                var w = textWords_1_1.value;
                if (startsWith(queryWord, w)) {
                    return true;
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (textWords_1_1 && !textWords_1_1.done && (_a = textWords_1.return)) _a.call(textWords_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return false;
    };
    try {
        for (var queryWords_1 = __values(queryWords), queryWords_1_1 = queryWords_1.next(); !queryWords_1_1.done; queryWords_1_1 = queryWords_1.next()) {
            var q = queryWords_1_1.value;
            if (!hasMatch(q)) {
                return false;
            }
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (queryWords_1_1 && !queryWords_1_1.done && (_a = queryWords_1.return)) _a.call(queryWords_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return true;
}
//# sourceMappingURL=matchesSearchQuery.js.map