import { TimeInterval } from 'd3-time';
export declare function parseTime(input: string | Date | undefined): Date | undefined;
export declare enum TimeGranularityKey {
    SECOND = "SECOND",
    MINUTE = "MINUTE",
    HOUR = "HOUR",
    DAY = "DAY",
    MONTH = "MONTH",
    YEAR = "YEAR"
}
export interface TimeGranularity {
    key: TimeGranularityKey;
    order: number;
    interval: TimeInterval;
    format: (date: Date) => string;
    formatFull: (date: Date) => string;
}
export declare function tickMultiFormat(date: Date): string;
export declare const TIME_GRANULARITIES: TimeGranularity[];
export declare function getTimeGranularityByOrder(order: number): TimeGranularity | undefined;
export declare function getTimeGranularityForDate(date: Date): TimeGranularity;
export declare function areRangesEqual(a: [Date, Date] | undefined, b: [Date, Date] | undefined): boolean;
//# sourceMappingURL=time.d.ts.map